Attribute VB_Name = "modHelper"
Option Explicit

'https://www.magnumdb.com

' ----==== Const ====----
Private Const GdiPlusVersion As Long = 1
Private Const EncoderParameterValueTypeLong As Long = 4
Private Const EncoderQuality As String = "{1D5BE4B5-FA4A-452D-9CDD-5DB35105E7EB}"
Private Const ImageFormatBMP As String = "{B96B3CAB-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatEMF As String = "{B96B3CAC-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatEXIF As String = "{B96B3CB2-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatGIF As String = "{B96B3CB0-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatIcon As String = "{B96B3CB5-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatJPEG As String = "{B96B3CAE-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatMemoryBMP As String = "{B96B3CAA-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatPNG As String = "{B96B3CAF-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatTIFF As String = "{B96B3CB1-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatUndefined As String = "{B96B3CA9-0728-11D3-9D7B-0000F81EF32E}"
Private Const ImageFormatWMF As String = "{B96B3CAD-0728-11D3-9D7B-0000F81EF32E}"
Private Const IID_IPicture As String = "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"
Private Const IID_IPropertyDescription As String = "{6F79D558-3E96-4549-A1D1-7D75D2288814}"
Public Const IID_IPropertyStore As String = "{886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99}"

' ----==== Enum ====----
Public Enum VARENUM
    VT_EMPTY = 0  '&H0
    VT_NULL = 1  '&H1
    VT_I2 = 2  '&H2
    VT_I4 = 3  '&H3
    VT_R4 = 4  '&H4
    VT_R8 = 5  '&H5
    VT_CY = 6  '&H6
    VT_DATE = 7  '&H7
    VT_BSTR = 8  '&H8
    VT_DISPATCH = 9  '&H9
    VT_ERROR = 10  '&HA
    VT_BOOL = 11  '&HB
    VT_VARIANT = 12  '&HC
    VT_UNKNOWN = 13  '&HD
    VT_DECIMAL = 14  '&HE
    VT_I1 = 16  '&H10
    VT_UI1 = 17  '&H11
    VT_UI2 = 18  '&H12
    VT_UI4 = 19  '&H13
    VT_I8 = 20  '&H14
    VT_UI8 = 21  '&H15
    VT_INT = 22  '&H16
    VT_UINT = 23  '&H17
    VT_VOID = 24  '&H18
    VT_HRESULT = 25  '&H19
    VT_PTR = 26  '&H1A
    VT_SAFEARRAY = 27  '&H1B
    VT_CARRAY = 28  '&H1C
    VT_USERDEFINED = 29  '&H1D
    VT_LPSTR = 30  '&H1E
    VT_LPWSTR = 31  '&H1F
    VT_RECORD = 36  '&H24
    VT_FILETIME = 64  '&H40
    VT_BLOB = 65  '&H41
    VT_STREAM = 66  '&H42
    VT_STORAGE = 67  '&H43
    VT_STREAMED_OBJECT = 68  '&H44
    VT_STORED_OBJECT = 69  '&H45
    VT_BLOB_OBJECT = 70  '&H46
    VT_CF = 71  '&H47
    VT_CLSID = 72  '&H48
    VT_VECTOR = 4096  '&H1000
    VT_ARRAY = 8192  '&H2000
    VT_BYREF = 16384  '&H4000
    VT_RESERVED = 32768  '&H8000
    VT_ILLEGAL = 65535 '&HFFFF
    VT_ILLEGALMASKED = 4095 '&HFFF
    VT_TYPEMASK = 4095 '&HFFF
End Enum

Public Enum CANONICALNAMES
    SystemAudioChannelCount
    SystemAudioEncodingBitrate
    SystemAudioFormat
    SystemAudioIsVariableBitRate
    SystemAudioSampleRate
    SystemAudioSampleSize
    SystemAudioStreamNumber
    SystemAuthor
    SystemComment
    SystemComputerName
    SystemCopyright
    SystemDateAccessed
    SystemDateCreated
    SystemDateImported
    SystemDateModified
    SystemDocumentDateCreated
    SystemDocumentDateSaved
    SystemDRMIsProtected
    SystemFileAttributes
    SystemFileAttributesDisplay
    SystemFileExtension
    SystemFileName
    SystemFileOwner
    SystemIsFolder
    SystemIsShared
    SystemItemAuthors
    SystemItemDate
    SystemItemFolderNameDisplay
    SystemItemFolderPathDisplay
    SystemItemFolderPathDisplayNarrow
    SystemItemName
    SystemItemNameDisplay
    SystemItemParticipants
    SystemItemPathDisplay
    SystemItemPathDisplayNarrow
    SystemItemType
    SystemItemTypeText
    SystemKind
    SystemKindText
    SystemLinkTargetExtension
    SystemLinkTargetParsingPath
    SystemLinkTargetSFGAOFlags
    SystemLinkTargetSFGAOFlagsStrings
    SystemMediaAuthorUrl
    SystemMediaDuration
    SystemMediaEncodedBy
    SystemMediaPublisher
    SystemMediaSubTitle
    SystemMediaYear
    SystemMusicAlbumArtist
    SystemMusicAlbumID
    SystemMusicAlbumTitle
    SystemMusicArtist
    SystemMusicBeatsPerMinute
    SystemMusicComposer
    SystemMusicConductor
    SystemMusicContentGroupDescription
    SystemMusicDisplayArtist
    SystemMusicGenre
    SystemMusicInitialKey
    SystemMusicIsCompilation
    SystemMusicMood
    SystemMusicPartOfSet
    SystemMusicTrackNumber
    SystemNetworkLocation
    SystemOfflineAvailability
    SystemOfflineStatus
    SystemParsingName
    SystemParsingPath
    SystemPerceivedType
    SystemRating
    SystemSFGAOFlags
    SystemSharedWith
    SystemSharingStatus
    SystemShellSFGAOFlagsStrings
    SystemSize
    SystemThumbnailCacheId
    SystemThumbnailStream
    SystemTitle
End Enum

Public Enum GETPROPERTYSTOREFLAGS
    GPS_DEFAULT = &H0
    GPS_HANDLERPROPERTIESONLY = &H1
    GPS_READWRITE = &H2
    GPS_TEMPORARY = &H4
    GPS_FASTPROPERTIESONLY = &H8
    GPS_OPENSLOWITEM = &H10
    GPS_DELAYCREATION = &H20
    GPS_BESTEFFORT = &H40
    GPS_NO_OPLOCK = &H80
    GPS_MASK_VALID = &HFF
End Enum

Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

' ----==== Sonstige Typen ====----
Public Type PicStreamData
    PicType As String
    PicSize As String
    PicKb As String
    Pic As StdPicture
End Type

Public Type iid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7)  As Byte
End Type

Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

Private Type EncoderParameter
    GUID As GUID
    NumberOfValues As Long
    Type As Long
    Value As Long
End Type

Private Type EncoderParameters
    Count As Long
    Parameter(15) As EncoderParameter
End Type

Private Type PICTDESC
    cbSizeOfStruct As Long
    PicType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliSeconds As Integer
End Type

Public Type PROPERTYKEY
    fmtid As GUID
    pid As Long
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
End Type

Public Type tagVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
End Type

' ----==== GDI+ API-Deklarationen ====----
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal image As Long) As Status

Private Declare Function GdipCreateBitmapFromStream Lib "gdiplus" (ByVal mStream As Any, ByRef mBitmap As Long) As Status

Private Declare Function GdipSaveImageToStream Lib "gdiplus" (ByVal image As Long, ByVal Stream As Any, _
                                                              ByRef clsidEncoder As GUID, ByRef encoderParams As Any) As Status
                         
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "gdiplus" (ByVal Bitmap As Long, ByRef hbmReturn As Long, ByVal Background As Long) As Status

Private Declare Function GdipCreateBitmapFromHBITMAP Lib "gdiplus" (ByVal hbm As Long, ByVal hpal As Long, ByRef Bitmap As Long) As Status

Private Declare Function GdipGetImageRawFormat Lib "gdiplus" (ByVal image As Long, ByRef format As GUID) As Status
                         
Private Declare Function GdipGetImageDimension Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mWidth As Single, ByRef mHeight As Single) As Status

Private Declare Function GdiplusShutdown Lib "gdiplus" (ByVal token As Long) As Status

Private Declare Function GdiplusStartup Lib "gdiplus" (ByRef token As Long, ByRef lpInput As GDIPlusStartupInput, _
                                                                            ByRef lpOutput As GdiplusStartupOutput) As Status

' ----==== Oleaut32 API-Deklarationen ====----
Private Declare Sub OleCreatePictureIndirect Lib "oleaut32.dll" (ByRef lpPictDesc As PICTDESC, ByRef riid As iid, ByVal fOwn As Boolean, ByRef lplpvObj As Object)

' ----==== Ole32 API-Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

Public Declare Function CLSIDFromString Lib "ole32.dll" (ByVal pString As Long, ByRef pCLSID As GUID) As Long

Public Declare Function StringFromCLSID Lib "ole32.dll" (ByRef pCLSID As GUID, ByRef lpszProgID As Long) As Long

Public Declare Function IIDFromString Lib "ole32.dll" (ByVal lpsz As Long, ByRef lpiid As iid) As Long
                        
Public Declare Function CreateStreamOnHGlobal Lib "ole32.dll" (ByVal hGlobal As Long, ByVal fDeleteOnRelease As Long, ByRef ppstm As Any) As Long
                         
' ----==== Shell32 API-Deklarationen ====----
Public Declare Function SHGetPropertyStoreFromParsingName Lib "shell32.dll" (ByVal pszPath As Long, ByVal pbc As Long, ByVal flags As GETPROPERTYSTOREFLAGS, _
                                                                                                    ByRef riid As GUID, ByRef ppv As Long) As Long

' ----==== Kernel32 API-Deklarationen ====----
Public Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (ByRef pTo As Any, ByRef uFrom As Any, ByVal lSize As Long)

Public Declare Function lstrlenW Lib "Kernel32" (ByVal lpString As Long) As Long

Private Declare Function FileTimeToSystemTime Lib "Kernel32.dll" (ByRef lpFileTime As FILETIME, ByRef lpSystemTime As SYSTEMTIME) As Long

' ----==== Propsys API-Deklarationen ====----
Public Declare Function PSGetPropertyKeyFromName Lib "propsys.dll" (ByVal pszName As Long, ByRef propkey As PROPERTYKEY) As Long
                        
Public Declare Function PSGetNameFromPropertyKey Lib "propsys.dll" (ByRef propkey As PROPERTYKEY, ByRef ppszCanonicalName As Long) As Long

Public Declare Function PSGetPropertyDescription Lib "propsys.dll" (ByRef propkey As PROPERTYKEY, ByRef riid As GUID, ByRef ppv As Long) As Long

Public Function GetPropertyDescription(ByVal eCanonicalName As CANONICALNAMES) As String

    Dim sRet As String
    Dim psIID As Long
    Dim pIPropertyDescription As Long
    Dim tGUID As GUID
    Dim IPropertyDescription As clsIPropertyDescription

    sRet = vbNullString
    psIID = StrPtr(IID_IPropertyDescription)

    If CLSIDFromString(psIID, tGUID) = S_OK Then

        If PSGetPropertyDescription(CanonicalToPropKey(eCanonicalName), tGUID, pIPropertyDescription) = S_OK Then

            Set IPropertyDescription = New clsIPropertyDescription

            Call IPropertyDescription.Initialize(pIPropertyDescription)
            Call IPropertyDescription.RaiseError(False)

            sRet = IPropertyDescription.GetDisplayName

            Set IPropertyDescription = Nothing

        End If
    End If

    If sRet = vbNullString Then

        Select Case eCanonicalName

           Case CANONICALNAMES.SystemAudioIsVariableBitRate
               sRet = "VBR"
   
           Case Else

        End Select

    End If

    GetPropertyDescription = sRet

End Function

Public Function CanonicalToPropKey(ByVal eCanonicalName As CANONICALNAMES) As PROPERTYKEY

    Dim sRet As String
    Dim pRet As Long
    Dim tPROPERTYKEY As PROPERTYKEY
    
    Select Case eCanonicalName

    Case SystemItemFolderNameDisplay
        sRet = "System.ItemFolderNameDisplay"

    Case SystemItemTypeText
        sRet = "System.ItemTypeText"

    Case SystemItemNameDisplay
        sRet = "System.ItemNameDisplay"

    Case SystemSize
        sRet = "System.Size"

    Case SystemFileAttributes
        sRet = "System.FileAttributes"

    Case SystemDateModified
        sRet = "System.DateModified"

    Case SystemDateCreated
        sRet = "System.DateCreated"

    Case SystemDateAccessed
        sRet = "System.DateAccessed"

    Case SystemTitle
        sRet = "System.Title"

    Case SystemAuthor
        sRet = "System.Author"

    Case SystemDocumentDateCreated
        sRet = "System.Document.DateCreated"

    Case SystemDocumentDateSaved
        sRet = "System.Document.DateSaved"

    Case SystemThumbnailStream
        sRet = "System.ThumbnailStream"

    Case SystemAudioFormat
        sRet = "System.Audio.Format"

    Case SystemMediaDuration
        sRet = "System.Media.Duration"

    Case SystemAudioEncodingBitrate
        sRet = "System.Audio.EncodingBitrate"

    Case SystemAudioSampleRate
        sRet = "System.Audio.SampleRate"

    Case SystemAudioSampleSize
        sRet = "System.Audio.SampleSize"

    Case SystemAudioChannelCount
        sRet = "System.Audio.ChannelCount"

    Case SystemAudioStreamNumber
        sRet = "System.Audio.StreamNumber"

    Case SystemCopyright
        sRet = "System.Copyright"

    Case SystemMusicComposer
        sRet = "System.Music.Composer"

    Case SystemMediaPublisher
        sRet = "System.Media.Publisher"

    Case SystemMediaAuthorUrl
        sRet = "System.Media.AuthorUrl"

    Case SystemMediaEncodedBy
        sRet = "System.Media.EncodedBy"

    Case SystemFileOwner
        sRet = "System.FileOwner"

    Case SystemNetworkLocation
        sRet = "System.NetworkLocation"

    Case SystemComputerName
        sRet = "System.ComputerName"

    Case SystemItemPathDisplayNarrow
        sRet = "System.ItemPathDisplayNarrow"

    Case SystemPerceivedType
        sRet = "System.PerceivedType"

    Case SystemItemType
        sRet = "System.ItemType"

    Case SystemParsingName
        sRet = "System.ParsingName"

    Case SystemSFGAOFlags
        sRet = "System.SFGAOFlags"

    Case SystemParsingPath
        sRet = "System.ParsingPath"

    Case SystemMusicArtist
        sRet = "System.Music.Artist"

    Case SystemMusicAlbumTitle
        sRet = "System.Music.AlbumTitle"

    Case SystemMediaYear
        sRet = "System.Media.Year"

    Case SystemMusicTrackNumber
        sRet = "System.Music.TrackNumber"

    Case SystemMusicGenre
        sRet = "System.Music.Genre"

    Case SystemMusicAlbumArtist
        sRet = "System.Music.AlbumArtist"

    Case SystemMusicContentGroupDescription
        sRet = "System.Music.ContentGroupDescription"

    Case SystemMusicInitialKey
        sRet = "System.Music.InitialKey"

    Case SystemMusicBeatsPerMinute
        sRet = "System.Music.BeatsPerMinute"

    Case SystemMusicConductor
        sRet = "System.Music.Conductor"

    Case SystemMusicPartOfSet
        sRet = "System.Music.PartOfSet"

    Case SystemMediaSubTitle
        sRet = "System.Media.SubTitle"

    Case SystemMusicMood
        sRet = "System.Music.Mood"

    Case SystemMusicAlbumID
        sRet = "System.Music.AlbumID"

    Case SystemFileExtension
        sRet = "System.FileExtension"

    Case SystemItemDate
        sRet = "System.ItemDate"

    Case SystemKindText
        sRet = "System.KindText"

    Case SystemFileAttributesDisplay
        sRet = "System.FileAttributesDisplay"

    Case SystemItemParticipants
        sRet = "System.ItemParticipants"

    Case SystemIsShared
        sRet = "System.IsShared"

    Case SystemSharedWith
        sRet = "System.SharedWith"

    Case SystemSharingStatus
        sRet = "System.SharingStatus"

    Case SystemItemName
        sRet = "System.ItemName"

    Case SystemShellSFGAOFlagsStrings
        sRet = "System.Shell.SFGAOFlagsStrings"

    Case SystemLinkTargetSFGAOFlagsStrings
        sRet = "System.Link.TargetSFGAOFlagsStrings"

    Case SystemDRMIsProtected
        sRet = "System.DRM.IsProtected"

    Case SystemOfflineAvailability
        sRet = "System.OfflineAvailability"

    Case SystemKind
        sRet = "System.Kind"

    Case SystemItemFolderPathDisplayNarrow
        sRet = "System.ItemFolderPathDisplayNarrow"

    Case SystemFileName
        sRet = "System.FileName"

    Case SystemMusicIsCompilation
        sRet = "System.Music.IsCompilation"

    Case SystemThumbnailCacheId
        sRet = "System.ThumbnailCacheId"

    Case SystemItemAuthors
        sRet = "System.ItemAuthors"

    Case SystemItemAuthors
        sRet = "System.ItemAuthors"

    Case SystemLinkTargetParsingPath
        sRet = "System.Link.TargetParsingPath"

    Case SystemLinkTargetSFGAOFlags
        sRet = "System.Link.TargetSFGAOFlags"

    Case SystemItemFolderPathDisplay
        sRet = "System.ItemFolderPathDisplay"

    Case SystemItemPathDisplay
        sRet = "System.ItemPathDisplay"

    Case SystemItemPathDisplay
        sRet = "System.ItemPathDisplay"

    Case SystemLinkTargetExtension
        sRet = "System.Link.TargetExtension"

    Case SystemOfflineStatus
        sRet = "System.OfflineStatus"

    Case SystemIsFolder
        sRet = "System.IsFolder"

    Case SystemDateImported
        sRet = "System.DateImported"

    Case SystemAudioIsVariableBitRate
        sRet = "System.Audio.IsVariableBitRate"

    Case SystemMusicDisplayArtist
        sRet = "System.Music.DisplayArtist"

    Case SystemRating
        sRet = "System.Rating"
    
    Case SystemComment
        sRet = "System.Comment"
    
    Case Else
        sRet = vbNullString

    End Select

    
    If sRet <> vbNullString Then
    
        pRet = StrPtr(sRet)
        
        If PSGetPropertyKeyFromName(pRet, tPROPERTYKEY) = S_OK Then
            CanonicalToPropKey = tPROPERTYKEY
        End If
    
    End If

End Function

Public Function DeleteMp3Tag(ByVal sFileName As String, ByVal eCanonicalName As CANONICALNAMES) As Boolean

    Dim bRet As Boolean
    Dim psIID As Long
    Dim psFileName As Long
    Dim pIPropertyStore As Long
    Dim tGUID As GUID
    Dim tPROPERTYKEY As PROPERTYKEY
    Dim eVARENUM As VARENUM
    Dim IPropertyStore As clsIPropertyStore

    If sFileName <> vbNullString Then

        psIID = StrPtr(IID_IPropertyStore)
        psFileName = StrPtr(sFileName)
        tPROPERTYKEY = CanonicalToPropKey(eCanonicalName)

        If CLSIDFromString(psIID, tGUID) = S_OK Then

            If SHGetPropertyStoreFromParsingName(psFileName, 0&, GPS_HANDLERPROPERTIESONLY Or GPS_READWRITE, tGUID, pIPropertyStore) = S_OK Then

                Set IPropertyStore = New clsIPropertyStore
                Call IPropertyStore.Initialize(pIPropertyStore)

                bRet = IPropertyStore.DeleteValue(tPROPERTYKEY)

                Set IPropertyStore = Nothing

            End If
        End If
    End If

    DeleteMp3Tag = bRet

End Function

Public Function SaveMp3Tag(ByVal sFileName As String, ByVal eCanonicalName As CANONICALNAMES, ByVal NewValue As Variant) As Boolean

    Dim bRet As Boolean
    Dim psIID As Long
    Dim psFileName As Long
    Dim pIPropertyStore As Long
    Dim pIPropertyDescription As Long
    Dim tGUID As GUID
    Dim tPROPERTYKEY As PROPERTYKEY
    Dim eVARENUM As VARENUM
    Dim IPropertyStore As clsIPropertyStore
    Dim IPropertyDescription As clsIPropertyDescription
    
    If sFileName <> vbNullString Then
    
        tPROPERTYKEY = CanonicalToPropKey(eCanonicalName)
    
        psIID = StrPtr(IID_IPropertyDescription)

        If CLSIDFromString(psIID, tGUID) = S_OK Then

            If PSGetPropertyDescription(tPROPERTYKEY, tGUID, pIPropertyDescription) = S_OK Then

                Set IPropertyDescription = New clsIPropertyDescription
                Call IPropertyDescription.Initialize(pIPropertyDescription)

                eVARENUM = IPropertyDescription.GetPropertyType

                Set IPropertyDescription = Nothing

            End If
        End If
        
        psIID = StrPtr(IID_IPropertyStore)
        psFileName = StrPtr(sFileName)

        If CLSIDFromString(psIID, tGUID) = S_OK Then

            If SHGetPropertyStoreFromParsingName(psFileName, 0&, GPS_HANDLERPROPERTIESONLY Or GPS_READWRITE, tGUID, pIPropertyStore) = S_OK Then

                Set IPropertyStore = New clsIPropertyStore
                Call IPropertyStore.Initialize(pIPropertyStore)
                Call IPropertyStore.RaiseError(False)

                Select Case eVARENUM
                
                Case VARENUM.VT_UI4
                    bRet = IPropertyStore.SetValueUI4(tPROPERTYKEY, CLng(NewValue))
                
                Case VARENUM.VT_BOOL
                    bRet = IPropertyStore.SetValueBool(tPROPERTYKEY, CBool(NewValue))
                
                Case VARENUM.VT_LPWSTR
                    bRet = IPropertyStore.SetValueStr(tPROPERTYKEY, CStr(NewValue))
                
                Case VARENUM.VT_STREAM
                    bRet = IPropertyStore.SetValueStream(tPROPERTYKEY, NewValue)
                
                Case VARENUM.VT_VECTOR Or VARENUM.VT_LPWSTR
                    bRet = IPropertyStore.SetValueStrArray(tPROPERTYKEY, CStr(NewValue))
                
                Case Else
                    bRet = False

                End Select

                Set IPropertyStore = Nothing

            End If
        End If
    End If

    SaveMp3Tag = bRet

End Function

Public Function ImportCoverFromDisc(ByVal sFileName As String, ByRef oCD As CommonDialog) As Boolean

    On Error GoTo MyErrorHandler

    Dim bRet As Boolean
    Dim psIID As Long
    Dim pbData As Long
    Dim psFileName As Long
    Dim pIPropertyStore As Long
    Dim tGUID As GUID
    Dim tPROPERTYKEY As PROPERTYKEY
    Dim IPropertyStore As clsIPropertyStore
    Dim sLoadFileName
    Dim lFNr As Long
    Dim pIStream As Long
    Dim bData() As Byte
    Dim IStream As clsIStream

Call Text_Anfgen(Now() & "   Start    ImportCoverFromDisc")

    If sFileName <> vbNullString Then

        With oCD
        
            .CancelError = True
            .InitDir = p_Def_Path
            .FileName = "*.jpg"
            .Filter = "*.jpg (JPEG Files)"
            .ShowOpen
            sLoadFileName = .FileName

        End With

        If sLoadFileName = "*.jpg" Then Exit Function

        If sLoadFileName <> vbNullString Then

Call Text_Anfgen("nach    sLoadFileName  = " & sLoadFileName)

        lFNr = FreeFile

            Open sLoadFileName For Binary Access Read As lFNr

            ReDim bData(LOF(lFNr) - 1)

            Get lFNr, , bData

            Close lFNr

            psIID = StrPtr(IID_IPropertyStore)
            psFileName = StrPtr(sFileName)

            If CLSIDFromString(psIID, tGUID) = S_OK Then

                If SHGetPropertyStoreFromParsingName(psFileName, 0&, _
                    GPS_HANDLERPROPERTIESONLY Or GPS_READWRITE, tGUID, pIPropertyStore) = S_OK Then

                    Set IPropertyStore = New clsIPropertyStore
                    Call IPropertyStore.Initialize(pIPropertyStore)

                    pbData = VarPtr(bData(0))

                    If CreateStreamOnHGlobal(pbData, True, pIStream) = S_OK Then

                        Set IStream = New clsIStream
                        Call IStream.Initialize(pIStream)
                        
Call Text_Anfgen("nach    Call IStream.Initialize(pIStream)")

                        If IPropertyStore.SetValueStream(CanonicalToPropKey(SystemThumbnailStream), pIStream) = True Then
                        
'old                        If IPropertyStore.SetValueStream(CanonicalToPropKey(SystemThumbnailStream), IStream) = True Then

Call Text_Anfgen("nach    If IPropertyStore.SetValueStream(CanonicalToPropKey(SystemThumbnailStream), IStream) = True Then")
                            bRet = True
                        End If

                        Set IStream = Nothing

                    End If

                    Set IPropertyStore = Nothing

                End If
            End If
        End If
    End If

    ImportCoverFromDisc = bRet

Call Text_Anfgen("ImportCoverFromDisc = bRet " & "   bRet = " & bRet)

Call Text_Anfgen("Direkt vor Exit Function in   ImportCoverFromDisc")

    Exit Function

MyErrorHandler:

Call Text_Anfgen(Error)

    Set IStream = Nothing
    Set IPropertyStore = Nothing
    
    oCD.CancelError = False
    ImportCoverFromDisc = False

End Function

Public Function ExportCoverToDisc(ByVal sFileName As String, ByRef oCD As CommonDialog) As Boolean

    On Error GoTo MyErrorHandler

    Dim bRet As Boolean
    Dim lBitmap As Long
    Dim hBitmap As Long
    Dim psIID As Long
    Dim psFileName As Long
    Dim pIPropertyStore As Long
    Dim strImageFormat As String
    Dim sSaveFileName
    Dim lGdipToken As Long
    Dim lSize As Long
    Dim bData() As Byte
    Dim tGUID As GUID
    Dim tGdipStartupInput As GDIPlusStartupInput
    Dim tGdipStartupOutput As GdiplusStartupOutput
    Dim IStream As clsIStream
    Dim IPropertyStore As clsIPropertyStore

    If sFileName <> vbNullString Then

        psIID = StrPtr(IID_IPropertyStore)
        psFileName = StrPtr(sFileName)

        If CLSIDFromString(psIID, tGUID) = S_OK Then

            If SHGetPropertyStoreFromParsingName(psFileName, 0&, GPS_DEFAULT, tGUID, pIPropertyStore) = S_OK Then

                Set IPropertyStore = New clsIPropertyStore

                Call IPropertyStore.Initialize(pIPropertyStore)

                Set IStream = IPropertyStore.GetValueStream(CanonicalToPropKey(SystemThumbnailStream))

                If Not IStream Is Nothing Then

                    tGdipStartupInput.GdiPlusVersion = GdiPlusVersion

                    If GdiplusStartup(lGdipToken, tGdipStartupInput, tGdipStartupOutput) = OK Then

                        If GdipCreateBitmapFromStream(IStream.GetInterfacePtr, lBitmap) = OK Then

                            If GdipGetImageRawFormat(lBitmap, tGUID) = OK Then

                                Select Case Guid2String(tGUID)

                                Case ImageFormatBMP
                                    strImageFormat = "bmp"

                                Case ImageFormatEMF
                                    strImageFormat = "emf"

                                Case ImageFormatEXIF
                                    strImageFormat = "exif"

                                Case ImageFormatGIF
                                    strImageFormat = "gif"

                                Case ImageFormatIcon
                                    strImageFormat = "ico"

                                Case ImageFormatJPEG
                                    strImageFormat = "jpg"

                                Case ImageFormatMemoryBMP
                                    strImageFormat = "MemoryBMP"

                                Case ImageFormatPNG
                                    strImageFormat = "png"

                                Case ImageFormatTIFF
                                    strImageFormat = "tif"

                                Case ImageFormatUndefined
                                    strImageFormat = "Undefined"

                                Case ImageFormatWMF
                                    strImageFormat = "wmf"

                                End Select

                            End If

                            Call GdipDisposeImage(lBitmap)

                        End If
                    End If

                    Call GdiplusShutdown(lGdipToken)

                    lSize = CLng(IStream.Seek_Stream(0&, STREAM_SEEK_END) * 10000)

                    Call IStream.Seek_Stream(0&, STREAM_SEEK_SET)

                    ReDim bData(lSize - 1)

                    If IStream.Read_Stream(bData, lSize) = lSize Then

                        Dim lFNr As Long

                        lFNr = FreeFile

                        With oCD

                            .CancelError = True
                            
                            .FileName = Replace$(sFileName, ".mp3", vbNullString) & "_Cover." & strImageFormat

                            .InitDir = p_Def_Path
                            .Filter = "*." & strImageFormat
                            .DefaultExt = "*." & strImageFormat
                            .ShowSave
                            sSaveFileName = .FileName

                        End With

                        If sSaveFileName <> vbNullString Then

                            If FileExists(sSaveFileName) = True Then

                                If MsgBox("Soll die vorhandene Datei ersetzt werden?", vbQuestion Or vbOKCancel, "Datei ersetzen") = vbOK Then

                                    bRet = True
                                    
                                    Call Kill(sSaveFileName)

                                    Open sSaveFileName For Binary Access Write As lFNr

                                    Put lFNr, , bData

                                    Close lFNr

                                Else
                                    bRet = False
                                End If

                            Else

                                bRet = True

                                Open sSaveFileName For Binary Access Write As lFNr

                                Put lFNr, , bData

                                Close lFNr

                            End If
                        End If
                    End If

                    Set IStream = Nothing

                End If
            End If
        End If
    End If

    ExportCoverToDisc = bRet

    Exit Function

MyErrorHandler:

    Set IStream = Nothing

    oCD.CancelError = False
    ExportCoverToDisc = False

End Function

Public Function GetPicFromStream(ByVal ImageStream As clsIStream) As PicStreamData

    Dim lBitmap As Long
    Dim hBitmap As Long
    Dim sWidth As Single
    Dim sHeight As Single
    Dim oPic As StdPicture
    Dim lGdipToken As Long
    Dim tGUID As GUID
    Dim tPicStreamData As PicStreamData
    Dim tGdipStartupInput As GDIPlusStartupInput
    Dim tGdipStartupOutput As GdiplusStartupOutput

    If Not ImageStream Is Nothing Then

        tGdipStartupInput.GdiPlusVersion = GdiPlusVersion

        If GdiplusStartup(lGdipToken, tGdipStartupInput, tGdipStartupOutput) = OK Then

            With tPicStreamData
            
            .PicKb = format$(CStr(CLng(ImageStream.Seek_Stream(0&, STREAM_SEEK_END) * 10000) / 1024), "#.00") & " KB"
            Call ImageStream.Seek_Stream(0&, STREAM_SEEK_SET)

                If GdipCreateBitmapFromStream(ImageStream.GetInterfacePtr, lBitmap) = OK Then

                    If GdipGetImageRawFormat(lBitmap, tGUID) = OK Then

                        Select Case Guid2String(tGUID)

                        Case ImageFormatBMP
                            .PicType = "bmp"

                        Case ImageFormatEMF
                            .PicType = "emf"

                        Case ImageFormatEXIF
                            .PicType = "exif"

                        Case ImageFormatGIF
                            .PicType = "gif"

                        Case ImageFormatIcon
                            .PicType = "ico"

                        Case ImageFormatJPEG
                            .PicType = "jpg"

                        Case ImageFormatMemoryBMP
                            .PicType = "MemoryBMP"

                        Case ImageFormatPNG
                            .PicType = "png"

                        Case ImageFormatTIFF
                            .PicType = "tif"

                        Case ImageFormatUndefined
                            .PicType = "Undefined"

                        Case ImageFormatWMF
                            .PicType = "wmf"

                        End Select

                    End If

                    If GdipGetImageDimension(lBitmap, sWidth, sHeight) = OK Then

                        .PicSize = CStr(sWidth) & "px x " & CStr(sHeight) & "px"

                    End If

                    If GdipCreateHBITMAPFromBitmap(lBitmap, hBitmap, 0&) = OK Then

                        Set .Pic = HandleToPicture(hBitmap, vbPicTypeBitmap)

                        Call GdipDisposeImage(lBitmap)

                    End If
                End If

            End With

            Call GdiplusShutdown(lGdipToken)

        End If

    End If

    GetPicFromStream = tPicStreamData

End Function

Public Function SetPicToStream(ByVal image As StdPicture) As clsIStream

    Dim bOK As Boolean
    Dim lBitmap As Long
    Dim lJpgQuality As Long
    Dim pIStream As Long
    Dim lGdipToken As Long
    Dim tGUID As GUID
    Dim IStream As clsIStream
    Dim tParams As EncoderParameters
    Dim tGdipStartupInput As GDIPlusStartupInput
    Dim tGdipStartupOutput As GdiplusStartupOutput

    bOK = False

    tGdipStartupInput.GdiPlusVersion = GdiPlusVersion

    If GdiplusStartup(lGdipToken, tGdipStartupInput, tGdipStartupOutput) = OK Then
        
        If CreateStreamOnHGlobal(0, True, pIStream) = S_OK Then

            If GdipCreateBitmapFromHBITMAP(image.Handle, 0&, lBitmap) = OK Then

                If CLSIDFromString(StrPtr(ImageFormatJPEG), tGUID) = S_OK Then

                    tParams.Count = 1
                    lJpgQuality = 85

                    With tParams.Parameter(0)

                        CLSIDFromString StrPtr(EncoderQuality), .GUID
                        .NumberOfValues = 1
                        .Type = EncoderParameterValueTypeLong
                        .Value = VarPtr(lJpgQuality)

                    End With

                    If GdipSaveImageToStream(lBitmap, pIStream, tGUID, tParams) = OK Then
                        
                        If pIStream <> 0 Then
                        
                            Set IStream = New clsIStream
                            Call IStream.Initialize(pIStream)
                            Call IStream.Seek_Stream(0&, STREAM_SEEK_SET)
                            
                        Else
                            Set IStream = Nothing
                        End If
                    End If
                End If

                Call GdipDisposeImage(lBitmap)

            End If
        End If

        Call GdiplusShutdown(lGdipToken)

    End If

    Set SetPicToStream = IStream

End Function

Private Function HandleToPicture(ByVal hGDIHandle As Long, ByVal ObjectType As PictureTypeConstants, Optional ByVal hpal As Long = 0&) As StdPicture

    Dim tIID As iid
    Dim tPictDesc As PICTDESC
    Dim oPicture As IPicture
    Dim pIID_IPicture As Long

    pIID_IPicture = StrPtr(IID_IPicture)

    If IIDFromString(pIID_IPicture, tIID) = S_OK Then

        With tPictDesc

            .cbSizeOfStruct = Len(tPictDesc)
            .PicType = ObjectType
            .hgdiObj = hGDIHandle
            .hPalOrXYExt = hpal

        End With

        Call OleCreatePictureIndirect(tPictDesc, tIID, True, oPicture)

    End If

    Set HandleToPicture = oPicture

End Function

Public Function StringFromFileTime(ByRef tFILETIME As FILETIME) As String

    Dim sRet As String
    Dim tSYSTEMTIME As SYSTEMTIME

        If FileTimeToSystemTime(tFILETIME, tSYSTEMTIME) <> 0 Then

            With tSYSTEMTIME

                sRet = format$(.wDay, "00") & "." & format$(.wMonth, "00") & _
                    "." & format$(.wYear, "0000") & " " & format$(.wHour, "00") & _
                    ":" & format$(.wMinute, "00") & ":" & format$(.wSecond, _
                    "00")

            End With

        End If

    StringFromFileTime = sRet

End Function

Public Function Guid2String(ByRef tGUID As GUID) As String

    Dim lGuid As Long
    
    Call StringFromCLSID(tGUID, lGuid)

    Guid2String = Ptr2Str(lGuid)

End Function

Public Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    lLen = lstrlenW(lpStrPointer) * 2 - 1

    If lLen > 0 Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)

        Call CoTaskMemFree(lpStrPointer)     '      Roger

        Ptr2Str = bBuffer

    End If

End Function

Public Function FileExists(ByVal FileName As String) As Boolean

    On Error Resume Next

    Dim ret As Long

    ret = Len(Dir$(FileName))

    If Err Or ret = 0 Then FileExists = False Else FileExists = True

End Function

